// myvisitor -- one of them, custom
// $Id: myvisitor1.h,v 1.15 2001/09/30 13:16:37 ar Exp $
//

#ifndef INCLUDED_MYVISITOR1_H
#define INCLUDED_MYVISITOR1_H

/* Copyright (C) 2001 ATRSoft GmbH 
   This file is part of the ATRSoft GmbH utilitys.

   The ATRSoft GmbH utilitys is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or any later version.

   The ATRSoft GmbH utilitys is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the ATRSoft GmbH utilitys; see the file LICENSE.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */


// http://www.atrsoft.de
// mailto: info@atrsoft.de


#ifndef INCLUDED_VOIDVISITORBASE_H
#    include "voidvisitorbase.h"
#    undef INCLUDED_VOIDVISITORBASE_H
#    define INCLUDED_VOIDVISITORBASE_H
#endif



#ifndef INCLUDED_MYVISITOR1IMPL_H
#    include "myvisitor1impl.h"
#    undef INCLUDED_MYVISITOR1IMPL_H
#    define INCLUDED_MYVISITOR1IMPL_H
#endif



#ifndef INCLUDED_MYVISITOR1WORD_H
#    include "myvisitor1word.h"
#    undef INCLUDED_MYVISITOR1WORD_H
#    define INCLUDED_MYVISITOR1WORD_H
#endif



#ifndef INCLUDED_MYVISITOR1PARAGRAPH_H
#    include "myvisitor1paragraph.h"
#    undef INCLUDED_MYVISITOR1PARAGRAPH_H
#    define INCLUDED_MYVISITOR1PARAGRAPH_H
#endif



#ifndef INCLUDED_MYVISITOR1GRAPHIC_H
#    include "myvisitor1graphic.h"
#    undef INCLUDED_MYVISITOR1GRAPHIC_H
#    define INCLUDED_MYVISITOR1GRAPHIC_H
#endif


// we use the adapter pattern for decoupling the visitors for a derived class

struct MyVisitor1 : public VoidVisitorBase, 
		    private MyVisitor1Impl, 
		    private myvisitor1paragraph, 
		    private myvisitor1word,
		    private myvisitor1graphic
{
    VoidVisitor::ReturnType 
    visit (ATRSoft::Pattern::VisitorAcceptor < Word, DocElement, VoidVisitor>* i_v)
	{
	     myvisitor1word :: visit (i_v, summ_);
	     return;
	}

    VoidVisitor::ReturnType 
    visit (ATRSoft::Pattern::VisitorAcceptor < Paragraph, DocElement, VoidVisitor>* i_v)
	{
	     myvisitor1paragraph :: visit (i_v, summ_);
	     return;
	}

    VoidVisitor::ReturnType 
    visit (ATRSoft::Pattern::VisitorAcceptor < Graphic, DocElement, VoidVisitor>* i_v)
	{
	     myvisitor1graphic :: visit (i_v, summ_);
	     return;
	}

    // make this accessible from outside
    ~MyVisitor1 () throw ()
	{
	    try
	    {
		MyVisitor1Impl::show ();
	    }
	    catch (...)
	    {
	    }
	}
};

#endif
// end of file


